<template>
    <q-card-section class="fit compare-parent" ref="parent">
        <q-resize-observer @resize="Resize"/>
        <div class="title" :style="TitleStyle">
            {{ title }}
        </div>
        <div class="full-width ">
            <div class="full-width vs">
                <div class="val">
                    <div class="left perc" :style="PercStyle">
                        {{ LeftPercentage }}
                    </div>
                    <div class="right" :style="ValStyle">
                        {{ Left }}
                    </div>
                </div>
                <div :style="VSStyle">
                    vs
                </div>
                <div class="val">
                    <div class="left" :style="ValStyle">
                        {{ Right }}
                    </div>
                    <div class="right perc" :style="PercStyle">
                        {{ RightPercentage }}
                    </div>
                </div>
            </div>
            <div class="full-width vs">
                <div class="left-bar" :style="BarHeight">
                    <div class="bar" :style="LeftBarStyle"/>
                </div>
                <div class="right-bar" :style="BarHeight">
                    <div class="bar" :style="RightBarStyle"/>
                </div>
            </div>
        </div>
        <div class="full-width labels">
            <div class="label left" :style="LabelStyle">
                {{ left }}
            </div>
            <div class="label right" :style="LabelStyle">
                {{ right }}
            </div>
        </div>

    </q-card-section>
</template>

<style lang='scss' scoped>

$left: rgb(90, 141, 238);
$right: rgb(255, 91, 92);


.label {
    padding: 1px 4px;
    border-radius: 2px;
    margin: 10px;
}

.labels {
    display: flex;
    align-items: center;
    justify-content: space-between;

    .left {
        background: $left;
        color: darken($left, 40%)
    }

    .right {
        background: $right;
        color: darken($right, 40%)
    }

}

.bar {
    height: 100%;
}

.left-bar {
    width: 100%;

    .bar {
        background: $left;
        right: 0;
    }
}

.right-bar {
    width: 100%;

    .bar {
        background: $right;
        left: 0;
    }
}

.val {
    display: flex;
    justify-content: space-between;
    align-items: center;
    margin: 10px;
    width: 100%;
}

.perc {
    background: #E4F0DB;
    color: #71B043;
    padding: 2px 4px;
    border-radius: 1px;
}

.left {
    text-align: left;
}

.right {
    text-align: right;
}


.vs {
    display: flex;
    flex-direction: row;
    justify-content: center;
    align-items: center;
}

.title {
    font-family: Raleway, 'sans-serif';
    text-transform: uppercase;
    text-align: center;
}

.compare-parent {
    display: flex;
    flex-direction: column;
    align-items: center;
    justify-content: space-between;
}
</style>

<script lang='ts'>
import {Component, Prop, Vue} from 'vue-property-decorator';
import {MetricValue} from "src/classLibrary/Dashboard/SingeMetricQuery";
import {FormatDuration} from "src/classLibrary/Utility";

@Component
export default class CompareMetric extends Vue {
    @Prop() title!: string;
    @Prop() left!: string;
    @Prop() right!: string;
    @Prop() leftValue!: MetricValue;
    @Prop() rightValue!: MetricValue;

    w: number = 200;
    h: number = 200;

    get RightBarStyle() {
        const left = this.UnWrapRaw(this.leftValue), right = this.UnWrapRaw(this.rightValue);
        const width = (right / (right + left)) * 200 + "%"
        return {
            width,
        }
    }

    get BarHeight() {
        const height = (this.h / 50) + "px";
        return {
            height,
        }
    }

    get LeftBarStyle() {
        const left = this.UnWrapRaw(this.leftValue), right = this.UnWrapRaw(this.rightValue);
        const width = (left / (right + left)) * 200 + "%"
        return {
            width,
        }
    }

    get LabelStyle() {
        const fontSize = (this.w / 40) + "px"
        return {
            fontSize,
        }
    }

    get VSStyle() {
        const fontSize = (this.w / 35) + "px"
        return {
            fontSize,
        }
    }

    get ValStyle() {
        const fontSize = (this.w / 15) + "px"
        return {
            fontSize,
        }
    }

    get PercStyle() {
        const fontSize = (this.w / 35) + "px"
        return {
            fontSize,
        }
    }

    get TitleStyle() {
        const fontSize = (this.w / 30) + "px"
        return {
            fontSize,
        }
    }

    UnWrapRaw(m: MetricValue): number {
        return MetricValue.match(m, {
            Count(p0: number) {
                return p0;
            }, Duration(p0: number) {
                return p0;
            }
        })
    }

    get P() {
        const left = this.UnWrapRaw(this.leftValue), right = this.UnWrapRaw(this.rightValue);
        if (left > right) {
            return (left / right) * 100 - 100;
        } else {
            return (right / left) * 100 - 100;
        }
    }

    get Percentage() {
        return "+" + this.P.ToInt() + "%"
    }


    get RightPercentage() {
        return !this.ShowLeft ? this.Percentage : '';
    }

    get LeftPercentage() {
        return this.ShowLeft ? this.Percentage : '';
    }

    get ShowLeft() {
        const left = this.UnWrapRaw(this.leftValue), right = this.UnWrapRaw(this.rightValue);
        return left > right;
    }

    get Right() {
        return MetricValue.match(this.rightValue, {
            Count(p0: number) {
                return p0.toFixed(2).ToFloat().toLocaleString();
            }, Duration(seconds: number) {
                return FormatDuration({seconds}, true);
            }
        })
    }

    get Left() {
        return MetricValue.match(this.leftValue, {
            Count(p0: number) {
                return p0.toFixed(2).ToFloat().toLocaleString();
            }, Duration(seconds: number) {
                return FormatDuration({seconds}, true);
            }
        })
    }

    Resize() {
        const parent = (this.$refs.parent as any).$el as HTMLElement;
        this.w = parent.getBoundingClientRect().width;
        this.h = parent.getBoundingClientRect().height;
    }
}
</script>
